/*
 *
 *    soniK digital audio editor
 *    Copyright (C) 2003-2006  Robert Walker <rob@tenfoot.org.uk>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#include "gainmatrix.h"

using Sonik::GainMatrix;

GainMatrix::GainMatrix(size_t inChannels, size_t outChannels)
{
  resize(inChannels, outChannels);
}

GainMatrix::~GainMatrix()
{
}

void GainMatrix::resize(size_t inChannels, size_t outChannels)
{
  mData.resize(inChannels);
  for (QValueVector<OutputGains>::iterator it = mData.begin();
       it != mData.end();
       ++it)
  {
    (*it).resize(outChannels, 0.0f);
  }
}

void GainMatrix::zero()
{
  for (QValueVector<OutputGains>::iterator i = mData.begin();
       i != mData.end();
       ++i)
  {
    for (OutputGains::iterator o = (*i).begin(); o != (*i).end(); ++o)
      (*o) = 0.0f;
  }
}
